''=======[ Constants ]=============================================
CON
'' +++++++[ Clock Frequency ]++++++++++++++++++++++++++++++++++++++++++++
  _clkmode = xtal1 + pll16x             'Standard clock mode * crystal frequency = 80 MHz
  _xinfreq = 5_000_000


'' +++++++[DS1621 address ]++++++++++++++++++++++++++++++++++++++++++++
  Addr = %1001_0000

''=======[ Variables ]=============================================
VAR
  long tempvar,TH,TL
  long PIDin,PIDout


''=======[ Objects ]=============================================
OBJ
  pst   : "Parallax Serial Terminal"
  DS1621: "DS1621Obj.spin"
  PWM   : "PWM_32_v4.spin"
  PID   : "PID.spin"

''=======[ Main Method ]=============================================
PUB main
''DESCRIPTION:
''PARMS:
''RETURNS:

  ''Port directions; DON'T change!!!
  ''Outputs


  ''Start some drivers and new cogs
  '********************************
  PST.Start(115200)
  PWM.start

  ''Initialise some variables
  '**************************
  TL := 34
  TH := 34
  DS1621.writeConfig(28,Addr,2)
  DS1621.writeTL(28,Addr,TL)
  DS1621.writeTH(28,Addr,TH)
  DS1621.startconversion(28,Addr)
  waitcnt(clkfreq/100 + CNT)


  ''INIT PWM and PID
  '*********
  'PWM.Duty(9,50,1000)  'Duty(Pin,DutyCycle,Period in microseconds)
  PID.init(1.5,0.6,0.0,34.0,5.0,50.0,-50.0)  'init (_Kp, _Ki, _Kd, setPoint, offset, maxArea, minArea)

  ''Main loop
  '**********  
  REPEAT
    pst.str(string("Temp: "))
    tempvar := DS1621.readTempC(28,Addr)
    pst.dec(tempvar)
    PIDout := PID.calculate(tempvar)
    pst.newline
    pst.str(string("PIDout: "))   
    pst.dec(PIDout)
    pst.newline
    'pst.bin(PIDout,8)
    'pst.newline    
    PWM.Duty(9,PIDout,1000)
    waitcnt(clkfreq/4 + CNT)


''=======[ Additional Methods ]=============================================


''=======[ DAT / Assembler ]=============================================
DAT           org
''Global Variables
